3 # koha-zebra - Manage Zebra daemons for Koha instances
4 # Copyright 2016 Theke Solutions
5 # Copyright 2010 Catalyst IT, Ltd
7 # This program is free software: you can redistribute it and/or modify
8 # it under the terms of the GNU General Public License as published by
9 # the Free Software Foundation, either version 3 of the License, or
10 # (at your option) any later version.
12 # This program is distributed in the hope that it will be useful,
13 # but WITHOUT ANY WARRANTY; without even the implied warranty of
14 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15 # GNU General Public License for more details.
17 # You should have received a copy of the GNU General Public License
18 # along with this program. If not, see <http://www.gnu.org/licenses/>.
22 .
/lib
/lsb
/init-functions
24 # Read configuration variable file if it is present
25 [ -r /etc
/default
/koha-common
] && .
/etc
/default
/koha-common
27 # include helper functions
28 if [ -f "/usr/share/koha/bin/koha-functions.sh" ]; then
29 .
"/usr/share/koha/bin/koha-functions.sh"
31 echo "Error: /usr/share/koha/bin/koha-functions.sh not present." 1>&2
37 local scriptname
=$
(basename $0)
42 This script lets you manage the Zebra daemon for your Koha instances.
45 $scriptname [--start|--stop|--restart] instancename1 [instancename2...]
48 --start Start the Zebra daemon for the specified instance(s)
49 --stop Stop the Zebra daemon for the specified instance(s)
50 --restart Restart the Zebra daemon for the specified instance(s)
51 --status Show the status of the Zebra daemon for the specified instance(s)
52 --verbose|-v Display progress and actions messages
53 --help|-h Display this help message
62 # get zebra log levels from koha-conf.xml
63 local loglevels
=$
(get_loglevels
${name})
64 local max_record_size
=$
(get_max_record_size
${name})
66 if ! is_zebra_running
$name; then
68 _check_and_fix_perms
${name}
70 DAEMONOPTS
="--name=${name}-koha-zebra \
71 --pidfiles=/var/run/koha/${name}/ \
72 --errlog=/var/log/koha/${name}/zebra-error.log \
73 --output=/var/log/koha/${name}/zebra-output.log \
77 --user=${name}-koha.${name}-koha"
79 ZEBRA_PARAMS
="-v $loglevels \
81 -f /etc/koha/sites/${name}/koha-conf.xml"
83 [ "$verbose" != "no" ] && \
84 log_daemon_msg
"Starting Koha Zebra daemon for ${name}"
86 if daemon
$DAEMONOPTS -- $ZEBRA_DAEMON $ZEBRA_PARAMS; then
87 ([ "$verbose" != "no" ] && \
88 log_end_msg
0) ||
return 0
90 ([ "$verbose" != "no" ] && \
91 log_end_msg
1) ||
return 1
94 if [ "$verbose" != "no" ]; then
95 log_daemon_msg
"Error: Zebra already running for ${name}"
107 if is_zebra_running
$name; then
109 DAEMONOPTS
="--name=${name}-koha-zebra \
110 --pidfiles=/var/run/koha/${name}/ \
111 --errlog=/var/log/koha/${name}/zebra-error.log \
112 --output=/var/log/koha/${name}/zebra-output.log \
116 --user=${name}-koha.${name}-koha"
118 [ "$verbose" != "no" ] && \
119 log_daemon_msg
"Stopping Koha Zebra daemon for ${name}"
121 if daemon
$DAEMONOPTS --stop -- $ZEBRA_DAEMON $ZEBRA_PARAMS; then
122 ([ "$verbose" != "no" ] && \
123 log_end_msg
0) ||
return 0
125 ([ "$verbose" != "no" ] && \
126 log_end_msg
1) ||
return 1
129 if [ "$verbose" != "no" ]; then
130 log_daemon_msg
"Error: Zebra not running for ${name}"
142 if is_zebra_running
${name}; then
144 [ "$verbose" != "no" ] && noLF
=""
145 echo $noLF `stop_zebra ${name}`
146 echo $noLF `start_zebra ${name}`
148 if [ "$verbose" != "no" ]; then
149 log_daemon_msg
"Error: Zebra not running for ${name}"
161 if is_zebra_running
${name}; then
162 log_daemon_msg
"Zebra running for ${name}"
165 log_daemon_msg
"Zebra not running for ${name}"
170 _check_and_fix_perms
()
174 local files
="/var/log/koha/${name}/zebra-output.log \
175 /var/log/koha/${name}/zebra-error.log"
179 if [ ! -e "${file}" ]; then
182 chown
"${name}-koha":"${name}-koha" ${file}
188 if [ "$op" = "" ]; then
191 die "Error
: only one action can be specified.
"
198 # Backwards compatible with old koha-*-zebra scripts
199 # TODO: Remove once there's consensus to remove the legacy scripts
200 used_script_name=$(basename $0)
202 if [ "$used_script_name" != "koha-zebra
" ]; then
203 warn "Deprecated
script used
(${used_script_name})"
205 case "$used_script_name" in
207 set_action "start
" ;;
211 set_action "restart
" ;;
216 # / Backwards compatible handling code
218 # Read command line parameters
219 while [ $# -gt 0 ]; do
240 die "Error
: invalid option switch
($1)" ;;
242 # We expect the remaining stuff are the instance names
248 ZEBRA_DAEMON=$(which zebrasrv)
250 if [ $# -gt 0 ]; then
251 # We have at least one instance name
254 if is_instance $name; then
271 if [ "$verbose" != "no
" ]; then
272 log_daemon_msg "Error
: Invalid instance name
$name"
279 if [ "$verbose" != "no
" ]; then
280 warn "Error
: you must provide
at least one instance name
"